#define d1 18 // датчик 1
#define d2 19 // датчик 2
#define d3 20 // датчик 3

//command
#define stop_sig 4094398824 // кнопка "выключение" на пульте
#define taran 4177957224 // кнопка "вперед" на пульте
#define clean 3827011944 // кнопка "плюс" на пульте

//motor port
#define enB 9
#define in3 8
#define in4 10
#define enA 5
#define in1 7
#define in2 6

#include <Wire.h>
#include <VL53L0X.h>
#include <IRremote.h>

IRrecv irrecv(15);
decode_results results;

VL53L0X sensor1;
VL53L0X sensor2;
VL53L0X sensor3;

int a = -1, b = -1, c = -1, kk = 0, distt = 40;
 
void setup()
{
  irrecv.enableIRIn();
  delay(5);
  pinMode(d1, OUTPUT);
  pinMode(d2, OUTPUT);
  pinMode(d3, OUTPUT);

  pinMode(enA, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);

  digitalWrite(d1, LOW);
  digitalWrite(d2, LOW);
  digitalWrite(d3, LOW);
  
  delay(2500);
  Wire.begin();
  Serial.begin(9600);

  /* 1 */

  digitalWrite(d1, HIGH);
  delay(150);
  Serial.print("1 sensor complete");
  sensor1.init(true);
  Serial.println();
  delay(100);
  sensor1.setAddress((uint8_t)01);

  /* 2 */
  digitalWrite(d2, HIGH);
  delay(150);
  Serial.print("2 sensor complete");
  sensor2.init(true);
  Serial.println();
  delay(100);
  sensor2.setAddress((uint8_t)02);
  /* 3 */

  digitalWrite(d3, HIGH);
  delay(150);
  Serial.print("3 sensor complete");
  sensor3.init(true);
  Serial.println();
  delay(100);
  sensor3.setAddress((uint8_t)03);
  /* end */

  sensor1.startContinuous();
  sensor2.startContinuous();
  sensor3.startContinuous();

  Serial.println("Start.");
}

void loop(){
  dist();
  kk = 0;
  if(IrReceiver.decode()){
    //Serial.println(IrReceiver.decodedIRData.decodedRawData);
    if(IrReceiver.decodedIRData.decodedRawData == clean){
      cleann();
    }
    else if(IrReceiver.decodedIRData.decodedRawData == stop_sig){
      stopp();
    }
    else if(IrReceiver.decodedIRData.decodedRawData == taran){
      Serial.println("Taran");
      delay(500);
      tarann();
    }
    irrecv.resume();
    delay(5);
  }
}



void dist(){
  a = sensor2.readRangeContinuousMillimeters();
  Serial.print(" a2: ");
  Serial.print(a / 10);
  
  b = sensor1.readRangeContinuousMillimeters();
  Serial.print(" d2: ");
  Serial.print(b / 10);

  c = sensor3.readRangeContinuousMillimeters();
  Serial.print(" d3: ");
  Serial.println(c / 10); 
}

void cleann(){
  analogWrite(enB, 255);
  analogWrite(enA, 255);

  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);

  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  delay(5500);

  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);

  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
}

void stopp(){
  analogWrite(enB, 0);
  analogWrite(enA, 0);

  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);

  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
}

void tarann(){
  delay(5);
  while(kk == 0){
    dist();
    if((sensor2.readRangeContinuousMillimeters() / 10) < distt && (sensor1.readRangeContinuousMillimeters() / 10) < distt && (sensor3.readRangeContinuousMillimeters() / 10) < distt){
      delay(5);
      analogWrite(enB, 0);
      analogWrite(enA, 0);

      digitalWrite(in3, LOW);
      digitalWrite(in4, LOW);

      digitalWrite(in1, LOW);
      digitalWrite(in2, LOW);
      if(IrReceiver.decode()){
        if(IrReceiver.decodedIRData.decodedRawData == stop_sig){
          kk = 1;
        }
        irrecv.resume();
        delay(5);
      }
    }
    else if ((sensor2.readRangeContinuousMillimeters() / 10) < distt){
      delay(5);
      analogWrite(enB, 255);
      analogWrite(enA, 255);

      digitalWrite(in3, HIGH);
      digitalWrite(in4, LOW);

      digitalWrite(in1, HIGH);
      digitalWrite(in2, LOW);
    }
    else if((sensor1.readRangeContinuousMillimeters() / 10) < distt){
      delay(5);
      while((sensor2.readRangeContinuousMillimeters() / 10) > distt){
        analogWrite(enB, 255);
        analogWrite(enA, 255);

        digitalWrite(in3, HIGH);
        digitalWrite(in4, LOW);

        digitalWrite(in1, LOW);
        digitalWrite(in2, HIGH);
      }
    }

    else if((sensor3.readRangeContinuousMillimeters() / 10) < distt){
      delay(5);
      while((sensor2.readRangeContinuousMillimeters() / 10) > distt){
        analogWrite(enB, 255);
        analogWrite(enA, 255);

        digitalWrite(in3, LOW);
        digitalWrite(in4, HIGH);

        digitalWrite(in1, HIGH);
        digitalWrite(in2, LOW);
      }
    }
    else{
      delay(5);
      analogWrite(enB, 255);
      analogWrite(enA, 255);

      digitalWrite(in3, LOW);
      digitalWrite(in4, HIGH);

      digitalWrite(in1, HIGH);
      digitalWrite(in2, LOW);
    }
    delay(5);
  }
}